#!/bin/sh

[ -n "$include_thumbnails" ] && return 0
include_thumbnails="$0"

gen_thumb(){
  file="$1"; thumb="$2";

  if [ ! -e "$thumb" ] && [ -f "$file" ]; then
    l="$(
      printf '' \
      | mplayer -input nodefault-bindings -nosound -vo null -identify -frames 0 "$file" 2>&- \
      | sed -rn 's:ID_LENGTH=(.*)(\..*)$:\1:p;' \
    )"
  
    chunk="$((${l:-10} / 5))"
    
    tmp="$(mktemp -d)"
    for cnt in 1 2 3 4; do
      printf '' \
      | mplayer -input nodefault-bindings -nosound -benchmark \
                -noconfig all -really-quiet \
                -frames 1 -ss "$((cnt * chunk))" \
                -vf framestep=I \
                -vo jpeg:quality=100:outdir="${tmp}" \
                "$file" 2>&-
      mv "${tmp}/00000001.jpg" "${tmp}/_${cnt}.jpg"
    done
    printf '' \
    | mplayer -input nodefault-bindings -nosound -benchmark \
              -noconfig all -really-quiet \
              -vf scale=159:-2,tile=2:2:4:0:2 \
              -vo jpeg:quality=96:outdir="${tmp}"\
              "mf://$tmp/_*.jpg" 2>&-
  
    mv "${tmp}/00000001.jpg" "$thumb"
    rm -r "${tmp}"
  
  elif [ ! -e "$thumb" ]; then
    touch "$thumb"
  fi
}
